﻿//---------------------------------------------------------------------------
//
//   MQMorphManager.h      Copyright(C) 1999-2019, tetraface Inc.
//
//		An accessor for morph information
//
//    　モーフ情報のアクセス
//
//---------------------------------------------------------------------------

#ifndef _MQMORPHMANAGER_H_
#define _MQMORPHMANAGER_H_

#include "MQBasePlugin.h"

class MQMorphManager
{
public:
	MQMorphManager(MQBasePlugin *plugin, MQDocument doc);

	static DWORD GetProductID();
	static DWORD GetPluginID();

	// Must call first in a 'Import' plugin.
	void BeginImport();
	// Must call last in a 'Import' plugin.
	void EndImport();

	enum TargetType {
		TARGET_DEFAULT = 0,
		TARGET_BROW,
		TARGET_EYE,
		TARGET_LIP,
		TARGET_OTHER,
	};

	int GetBaseObjectNum();
	int EnumBaseObjects(std::vector<MQObject>& base_objs);
	int GetTargetObjects(MQObject base, std::vector<MQObject>& target_objs);
	bool GetTargetType(MQObject base, MQObject target, TargetType& type);

	bool BindTargetObject(MQObject base, MQObject target);
	bool SetTargetType(MQObject base, MQObject target, TargetType type);

	bool ApplyDeformation(MQObject base, MQObject proxy);

	bool SetPMDMode(bool flag);

private:
	MQBasePlugin *m_Plugin;
	MQDocument m_Doc;
	bool m_Verified;
};


#endif //_MQMORPHMANAGER_H_
